<!--
  ~ Copyright (c) 2021. Julien Fischer
  ~
  ~  Licensed under the Apache License, Version 2.0 (the "License");
  ~  you may not use this file except in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~         http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing, software
  ~  distributed under the License is distributed on an "AS IS" BASIS,
  ~  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~  See the License for the specific language governing permissions and
  ~  limitations under the License.
  -->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <link rel="icon" type="image/png" sizes="32x32" href="../src/assets/branding/favicon-tests.png">
    <link rel="stylesheet" href="./lib/ui/dashboard.css">
    <link rel="stylesheet" href="../src/css/shared.css">
    <link rel="stylesheet" href="../src/css/themes/theme-light.css">
    <title>edit.js Tests</title>
</head>
<body class="theme-light">

    <section id="dashboard"></section>

    <!--------------------------------------------------------------------
                                PRODUCTION CODE
    --------------------------------------------------------------------->
    <!--    Constants    -->
    <script type="application/javascript" src="../src/js/constants/metadata/OutputPolicy.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/HeaderOrientation.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/BorderPolicy.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/FormatType.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/Format.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/CommentType.js"></script>
    <script type="application/javascript" src="../src/js/constants/Axis.js"></script>
    <script type="application/javascript" src="../src/js/models/Vector.js"></script>
    <script type="application/javascript" src="../src/js/constants/Direction.js"></script>
    <script type="application/javascript" src="../src/js/constants/Alignment.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/TextCase.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/JsonFormat.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/JavaFormat.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/CSharpFormat.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/PhpFormat.js"></script>
    <script type="application/javascript" src="../src/js/constants/metadata/PythonFormat.js"></script>
    <script type="application/javascript" src="../src/js/constants/HtmlEntities.js"></script>
    <script type="application/javascript" src="../src/js/constants/keyboard/Key.js"></script>
    <script type="application/javascript" src="../src/js/constants/keyboard/Modifier.js"></script>
    <script type="application/javascript" src="../src/js/constants/keyboard/KeyStroke.js"></script>
    <script type="application/javascript" src="../src/js/constants/keyboard/Context.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/ActionRequest.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/Side.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/Unicode.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/Icons.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/ButtonStyle.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/ButtonType.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/ScreenSize.js"></script>
    <script type="application/javascript" src="../src/js/constants/ui/Themes.js"></script>
    <script type="application/javascript" src="../src/js/Settings.js"></script>
    <!--    Internal    -->
    <script type="application/javascript" src="../src/js/internal/LogLevel.js"></script>
    <script type="application/javascript" src="../src/js/internal/Logger.js"></script>
    <!--    Utils    -->
    <script type="application/javascript" src="../src/js/utils/Values.js"></script>
    <script type="application/javascript" src="../src/js/utils/GUI.js"></script>
    <script type="application/javascript" src="../src/js/utils/TypeFunctions.js"></script>
    <script type="application/javascript" src="../src/js/utils/MatrixUtils.js"></script>
    <script type="application/javascript" src="../src/js/utils/ArrayUtils.js"></script>
    <script type="application/javascript" src="../src/js/utils/ObjectUtils.js"></script>
    <script type="application/javascript" src="../src/js/utils/StringUtils.js"></script>
    <script type="application/javascript" src="../src/js/utils/SpreadSheetUtils.js"></script>
    <script type="application/javascript" src="../src/js/utils/Enums.js"></script>
    <!--    I/O    -->
    <script type="application/javascript" src="../src/js/io/BorderFactory.js"></script>
    <script type="application/javascript" src="../src/js/io/TextBorder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/ParserResult.js"></script>
    <script type="application/javascript" src="../src/js/io/Languages.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/Encoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/PlainTextEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/GitHubMarkdownEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/ConfluenceEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/LatexEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/AsciiDocEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/MediaWikiEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/HtmlEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/BBCodeEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/CsvEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/SqlEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/encoding/encoders/CTypeEncoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/Decoders.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/Decoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/PlainTextDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/GitHubMarkdownDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/ConfluenceDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/LatexDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/AsciiDocDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/HtmlDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/BBCodeDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/MediaWikiDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/JsonDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/CsvDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/SqlDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/decoding/decoders/CTypeDecoder.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/TokenType.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/Token.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/Highlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/CTypeHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/PlainTextHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/TagBasedHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/MarkdownHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/SqlHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/CsvHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/LatexHighlighter.js"></script>
    <script type="application/javascript" src="../src/js/io/highlighting/highlighters/MediaWikiHighlighter.js"></script>
    <!--    Commands    -->
    <script type="application/javascript" src="../src/js/commands/InsertRowCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/RemoveRowCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/DuplicateRowCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/InsertColumnCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/RemoveColumnCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/DuplicateColumnCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/ClearCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/ResetCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/InputCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/SwapCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/AlignCommand.js"></script>
    <script type="application/javascript" src="../src/js/commands/ImportCommand.js"></script>
    <!--    Models, Events    -->
    <script type="application/javascript" src="../src/js/events/CellUpdate.js"></script>
    <script type="application/javascript" src="../src/js/events/ActiveCellEvent.js"></script>
    <script type="application/javascript" src="../src/js/models/TableMetadata.js"></script>
    <script type="application/javascript" src="../src/js/models/Rectangle.js"></script>
    <script type="application/javascript" src="../src/js/models/TableModel.js"></script>
    <script type="application/javascript" src="../src/js/models/Cell.js"></script>
    <script type="application/javascript" src="../src/js/models/Matrix.js"></script>
    <script type="application/javascript" src="../src/js/models/Occurrence.js"></script>
    <!--    Components    -->
    <script type="application/javascript" src="../src/js/components/dumb/Component.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/Tag.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/forms/Combobox.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/forms/TextField.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/buttons/ExpandButton.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/buttons/Button.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/buttons/CloseButton.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/buttons/ToggleButton.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/buttons/ButtonGroup.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/PopOver.js"></script>
    <script type="application/javascript" src="../src/js/components/dumb/Snackbar.js"></script>
    <script type="application/javascript" src="../src/js/components/controls/KeyEventProcessor.js"></script>
    <script type="application/javascript" src="../src/js/components/controls/Action.js"></script>
    <script type="application/javascript" src="../src/js/components/controls/EventProcessor.js"></script>
    <script type="application/javascript" src="../src/js/components/controls/CommandHistory.js"></script>
    <script type="application/javascript" src="../src/js/components/controls/TableReader.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/Toolbar.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/EditorTable.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/dialogs/ImportDialog.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/dialogs/CreateDialog.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/Editor.js"></script>
    <script type="application/javascript" src="../src/js/components/smart/TableRenderer.js"></script>

    <!--------------------------------------------------------------------
                                TESTING LIBRARY
    --------------------------------------------------------------------->
    <script type="application/javascript" src="./lib/constants/Status.js"></script>
    <script type="application/javascript" src="./lib/ui/svg/Donut.js"></script>
    <script type="application/javascript" src="./lib/ui/svg/Pie.js"></script>
    <script type="application/javascript" src="./lib/ui/svg/Spinner.js"></script>
    <script type="application/javascript" src="./lib/ui/StyleUtils.js"></script>
    <script type="application/javascript" src="./lib/ui/Snippet.js"></script>
    <script type="application/javascript" src="./lib/ui/CodeViewer.js"></script>
    <script type="application/javascript" src="./lib/ui/MetricsContainer.js"></script>
    <script type="application/javascript" src="./lib/ui/ResultTable.js"></script>
    <script type="application/javascript" src="./lib/ui/Accordion.js"></script>
    <script type="application/javascript" src="./lib/ui/DashboardControls.js"></script>
    <script type="application/javascript" src="./lib/ui/Dashboard.js"></script>
    <script type="application/javascript" src="./lib/functions.js"></script>
    <script type="application/javascript" src="./lib/models/Metrics.js"></script>
    <script type="application/javascript" src="./lib/models/TestSet.js"></script>
    <script type="application/javascript" src="./lib/models/TestResult.js"></script>
    <script type="application/javascript" src="./lib/Unit.js"></script>
    <script type="application/javascript" src="./lib/TestRunner.js"></script>

    <!--------------------------------------------------------------------
                                UNIT TESTS
    --------------------------------------------------------------------->
    <script type="application/javascript" src="./tests/utils/MatrixUtilsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/StringUtilsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/ArrayUtilsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/ObjectUtilsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/SpreadSheetUtilsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/EnumsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/TypeFunctionsTests.js"></script>
    <script type="application/javascript" src="./tests/utils/ValuesTests.js"></script>
    <script type="application/javascript" src="./tests/internal/LoggerTests.js"></script>
    <script type="application/javascript" src="./tests/models/RectangleTests.js"></script>
    <script type="application/javascript" src="./tests/models/MatrixTests.js"></script>
    <script type="application/javascript" src="./tests/models/VectorTests.js"></script>
    <script type="application/javascript" src="./tests/components/controls/ActionTests.js"></script>
    <script type="application/javascript" src="./tests/components/controls/EventProcessorTests.js"></script>
    <script type="application/javascript" src="./tests/components/HistoryTests.js"></script>
    <script type="application/javascript" src="./tests/components/ComboboxTests.js"></script>
    <script type="application/javascript" src="./tests/components/TableTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/PlainTextEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/HtmlEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/BBCodeEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/CsvEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/GitHubMarkdownEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/ConfluenceEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/LatexEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/AsciiDocEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/MediaWikiEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/SqlEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/encoding/encoders/CTypeEncoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/PlainTextDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/ParsersDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/GitHubMarkdownDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/ConfluenceDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/LatexDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/AsciiDocDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/MediaWikiDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/JsonDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/HtmlDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/BBCodeDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/CsvParserDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/SqlDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/decoding/decoders/CTypeDecoderTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/HighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/CTypeHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/PlainTextHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/TagBasedHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/MarkdownHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/SqlHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/CsvHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/LatexHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/highlighting/highlighters/MediaWikiHighlighterTests.js"></script>
    <script type="application/javascript" src="./tests/io/TableReaderTests.js"></script>

    <!-- Config -->
    <script type="application/javascript" src="./TestsSettings.js"></script>
    <script type="text/javascript">
        window.onload = () => {
            new TestRunner().execute(Unit.sets, TestsSettings);
        };
    </script>

</body>
</html>
